using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Space
{
    public class Space
    {
        public static void Main()
        {
          ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Thruster"),
                 NameOverride = "<color=purple>-SM<color=white> Large Rocket Engine",
                 NameToOrderByOverride = "Rocket Engine",
                 DescriptionOverride = "A powerful rocket engine.",
                 CategoryOverride = ModAPI.FindCategory("Machinery"),
                 ThumbnailOverride = ModAPI.LoadSprite("largeengine_view.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("largeengine.png", 1.0f);
                     Instance.transform.localRotation = Quaternion.Euler(180f, 180f, 180f + 90f);
                     Instance.FixColliders();
                 }
             }
           ); ;

          ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Mini Thruster"),
                 NameOverride = "<color=purple>-SM<color=white> Small Rocket Engine",
                 NameToOrderByOverride = "Small Rocket Engine",
                 DescriptionOverride = "A smaller, less powerful rocket engine.",
                 CategoryOverride = ModAPI.FindCategory("Machinery"),
                 ThumbnailOverride = ModAPI.LoadSprite("smallengine_view.png", 5f),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("smallengine.png", 1.0f);
                     Instance.transform.localRotation = Quaternion.Euler(180f, 180f, 180f + 90f);
                     Instance.FixColliders();
                 }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Stick"),
                NameOverride = "<color=purple>-SM<color=white> Parachute",
                NameToOrderByOverride = "Parachute",
                DescriptionOverride = "A parachute designed to slow down your rocket before landing.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("parachute_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("parachute.png");
                  Instance.FixColliders();
                  Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.4f;
                  Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.4f;
                  Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.4f;
                  Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -2.2f;
                  Instance.GetComponent<Rigidbody2D>().freezeRotation = true;
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Red Barrel"),
                NameOverride = "<color=purple>-SM<color=white> Large Fuel Tank",
                NameToOrderByOverride = "Large Fuel Tank",
                DescriptionOverride = "A large fuel tank. Highly flammable contents.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("fueltanklarge_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fueltanklarge.png");
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Red Barrel"),
                NameOverride = "<color=purple>-SM<color=white> Small Fuel Tank",
                NameToOrderByOverride = "Small Fuel Tank",
                DescriptionOverride = "A small fuel tank. Highly flammable contents.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("fueltanksmall_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fueltanksmall.png");
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Activation Fuse"),
                NameOverride = "<color=purple>-SM<color=white> Decoupler",
                NameToOrderByOverride = "Decoupler",
                DescriptionOverride = "On activation, a small explosive charge will separate any connected objects, allowing for rockets with multiple stages.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("decoupler_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("decoupler.png");
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Ion Thruster"),
                NameOverride = "<color=purple>-SM<color=white> Ion Thruster",
                NameToOrderByOverride = "Ion Thruster",
                DescriptionOverride = "This rocket engine is powered only by electricity and xenon gas, thus creating no flames and reducing vibrations.", //When half your description is basically stolen from the base game
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("ionengine_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ionengine.png");
                  Instance.transform.localRotation = Quaternion.Euler(180f, 180f, 180f + 90f);
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Red Barrel"),
                NameOverride = "<color=purple>-SM<color=white> Nose Cone",
                NameToOrderByOverride = "Nose Cone",
                DescriptionOverride = "A nose cone which also acts as a fuel tank. Highly flammable contents.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("nosecone_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("nosecone.png");
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Industrial Gyrostabiliser"),
                NameOverride = "<color=purple>-SM<color=white> Reaction Wheel",
                NameToOrderByOverride = "Reaction Wheel",
                DescriptionOverride = "A device which uses flywheels to rotate a spacecraft. In this case, it works as a stabilizer.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("reactionwheel_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("reactionwheel.png");
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                NameOverride = "<color=purple>-SM<color=white> Fin",
                NameToOrderByOverride = "Fin",
                DescriptionOverride = "A simple stabilizing fin to place at the bottom of your rocket. This doesn't actually stabilize anything, use a reaction wheel instead.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("fin_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fin.png");
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                NameOverride = "<color=purple>-SM<color=white> Decoupler Fairing (Simple)",
                NameToOrderByOverride = "Decoupler Fairing (Simple)",
                DescriptionOverride = "Basically walls for your decouplers. Use this to protect your payloads, for example an engine.\n<color=yellow>SIMPLE VERSION:\n<color=white>This is only one side of the fairing, so you need one on either side.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("fairing_simple_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fairing_simple.png");
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "<color=purple>-SM<color=white> Astronaut",
                NameToOrderByOverride = "Astronaut",
                DescriptionOverride = "A person to place inside your rocket. Wouldn't want to be him.",
                CategoryOverride = ModAPI.FindCategory("Entities"),
                ThumbnailOverride = ModAPI.LoadSprite("astronaut_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  var skin = ModAPI.LoadTexture("astronaut_skin.png");
                  var flesh = ModAPI.LoadTexture("astronaut_flesh.png");
                  var bone = ModAPI.LoadTexture("astronaut_bone.png");
                  var person = Instance.GetComponent<PersonBehaviour>();

                  person.SetBodyTextures(skin, flesh, bone, 1);
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                NameOverride = "<color=purple>-SM<color=white> Solar Panel",
                NameToOrderByOverride = "Solar Panel",
                DescriptionOverride = "A device which converts sunlight into power. This doesn't actually convert anything, and is just for decoration.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("solar_panel_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("solar_panel.png", 2f);
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                NameOverride = "<color=purple>-SM<color=white> Landing Legs (Side)",
                NameToOrderByOverride = "Landing Legs (Side)",
                DescriptionOverride = "Something that's better to land on than your engine. Side mounted.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("landing_legs_side_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("landing_legs_side.png", 1f);
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                NameOverride = "<color=purple>-SM<color=white> Landing Legs (Bottom)",
                NameToOrderByOverride = "Landing Legs (Side)",
                DescriptionOverride = "Something that's better to land on than your engine. Bottom mounted.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("landing_legs_bottom_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("landing_legs_bottom.png", 1f);
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                NameOverride = "<color=purple>-SM<color=white> Crew Pod",
                NameToOrderByOverride = "Crew Pod",
                DescriptionOverride = "A place for your victi- Uh, crew, to sit.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("crew_pod_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("crew_pod.png", 1f);
                  foreach (var c in Instance.GetComponents<Collider2D>())
                  {
                      GameObject.Destroy(c);
                  }

                  var top = Instance.AddComponent<BoxCollider2D>();
                  top.offset = new Vector2(0.0f * ModAPI.PixelSize, 42.0f * ModAPI.PixelSize);
                  top.size = new Vector2(32.0f * ModAPI.PixelSize, 1.0f * ModAPI.PixelSize);

                  var left = Instance.AddComponent<BoxCollider2D>();
                  left.offset = new Vector2(-16.0f * ModAPI.PixelSize, 0.0f * ModAPI.PixelSize);
                  left.size = new Vector2(1.0f * ModAPI.PixelSize, 84.0f * ModAPI.PixelSize);

                  var right = Instance.AddComponent<BoxCollider2D>();
                  right.offset = new Vector2(16.0f * ModAPI.PixelSize, 0.0f * ModAPI.PixelSize);
                  right.size = new Vector2(1.0f * ModAPI.PixelSize, 84.0f * ModAPI.PixelSize);

                  var bottom = Instance.AddComponent<BoxCollider2D>();
                  bottom.offset = new Vector2(0.0f * ModAPI.PixelSize, -42.0f * ModAPI.PixelSize);
                  bottom.size = new Vector2(32.0f * ModAPI.PixelSize, 1.0f * ModAPI.PixelSize);

                  var seatTop = Instance.AddComponent<BoxCollider2D>();
                  seatTop.offset = new Vector2(-9.0f * ModAPI.PixelSize, -25.0f * ModAPI.PixelSize);
                  seatTop.size = new Vector2(14.0f * ModAPI.PixelSize, 1.0f * ModAPI.PixelSize);

                  var seatSide = Instance.AddComponent<BoxCollider2D>();
                  seatSide.offset = new Vector2(-4.0f * ModAPI.PixelSize, -33.0f * ModAPI.PixelSize);
                  seatSide.size = new Vector2(1.0f * ModAPI.PixelSize, 16.0f * ModAPI.PixelSize);
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                NameOverride = "<color=purple>-SM<color=white> Decoupler Fairing (Advanced)",
                NameToOrderByOverride = "Decoupler Fairing (Advanced)",
                DescriptionOverride = "Basically walls for your decouplers. Use this to protect your payloads, for example an engine.\n<color=yellow>ADVANCED VERSION:\n<color=white>This is both side of the fairing as one object. You only need one per decoupler. Advanced version doesn't mean it's hard to use, just that the code is a tiny bit more advanced.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("fairing_advanced_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fairing_advanced.png", 1f);
                  foreach (var c in Instance.GetComponents<Collider2D>())
                  {
                      GameObject.Destroy(c);
                  }

                  var left = Instance.AddComponent<BoxCollider2D>();
                  left.offset = new Vector2(-16.0f * ModAPI.PixelSize, 0.0f * ModAPI.PixelSize);
                  left.size = new Vector2(4.0f * ModAPI.PixelSize, 16.0f * ModAPI.PixelSize);

                  var right = Instance.AddComponent<BoxCollider2D>();
                  right.offset = new Vector2(16.0f * ModAPI.PixelSize, 0.0f * ModAPI.PixelSize);
                  right.size = new Vector2(4.0f * ModAPI.PixelSize, 16.0f * ModAPI.PixelSize);
                }
             }
           ); ;

           // Hey! You found unused code! This was supposed to be the preassembled satellite in the payload update, but i cancelled it since the sprite was a bit too hard to make.
           // Also, it seemed kind of unnecessary since i was going to add a satellite body you can assemble yourself anyways.
           // If you find this message, feel free to tell me since this will most likely only be here for a bit, because i'll actually add the small satellite in the future
           // and then i'll remove this message.
           //
           // ModAPI.Register(
           //   new Modification()
           //   {
           //      OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
           //      NameOverride = "<color=purple>-SM<color=white> Pre-Assembled Satellite (Small)",
           //      NameToOrderByOverride = "Pre-Assembled Satellite",
           //      DescriptionOverride = "A small pre-assembled satellite for you to launch with your rockets. Includes a small, rectangular body, two small solar panels and an antenna.",
           //      CategoryOverride = ModAPI.FindCategory("Machinery"),
           //      ThumbnailOverride = ModAPI.LoadSprite("small_preassembled_satellite_view.png", 5f),
           //      AfterSpawn = (Instance) =>
           //      {
           //        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("small_preassembled_satellite.png", 1f);
           //        Instance.FixColliders();
           //      }
           //   }
           // ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                NameOverride = "<color=purple>-SM<color=white> Satellite Body (Medium)",
                NameToOrderByOverride = "Pre-Assembled Satellite",
                DescriptionOverride = "A medium satellite body you can attach other things to. Goes well with solar panels and ion engines.\n<color=yellow>NOTE:\n<color=white>There is currently no small or large version, only this medium one.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("medium_satellite_body_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("medium_satellite_body.png", 1f); // This sprite is pretty boring, i know.
                  Instance.FixColliders();
                }
             }
           ); ;

           ModAPI.Register(
             new Modification()
             {
                OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                NameOverride = "<color=purple>-SM<color=white> Satellite Dish (Medium)",
                NameToOrderByOverride = "Satellite Dish (Medium)",
                DescriptionOverride = "A medium satellite dish. Goes well with the medium satellite body.\n<color=yellow>NOTE:\n<color=white>There is currently no small or large version, only this medium one.",
                CategoryOverride = ModAPI.FindCategory("Machinery"),
                ThumbnailOverride = ModAPI.LoadSprite("medium_satellite_dish_view.png", 5f),
                AfterSpawn = (Instance) =>
                {
                  Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("medium_satellite_dish.png", 1f); // God this sprite is bad.
                  Instance.FixColliders();
                }
             }
           ); ;

         }
    }
}
